'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-d337cd8a.js');
const helpers = require('./helpers-fc4016d2.js');
const chevronIcon = require('./chevron-icon-3bf07531.js');

const icCardVerticalCss = "/*! normalize.css v8.0.1 | MIT License | github.com/necolas/normalize.css */\n\n/* Document\n   ========================================================================== */\n\n/**\n * 1. Correct the line height in all browsers.\n * 2. Prevent adjustments of font size after orientation changes in iOS.\n */\n\nhtml {\n  line-height: 1.15; /* 1 */\n  -webkit-text-size-adjust: 100%; /* 2 */\n}\n\n/* Sections\n     ========================================================================== */\n\n/**\n   * Remove the margin in all browsers.\n   */\n\nbody {\n  margin: 0;\n}\n\n/**\n   * Render the `main` element consistently in IE.\n   */\n\nmain {\n  display: block;\n}\n\n/**\n   * Correct the font size and margin on `h1` elements within `section` and\n   * `article` contexts in Chrome, Firefox, and Safari.\n   */\n\nh1 {\n  font-size: 2em;\n  margin: 0.67em 0;\n}\n\n/* Grouping content\n     ========================================================================== */\n\n/**\n   * 1. Add the correct box sizing in Firefox.\n   * 2. Show the overflow in Edge and IE.\n   */\n\nhr {\n  box-sizing: content-box; /* 1 */\n  height: 0; /* 1 */\n  overflow: visible; /* 2 */\n}\n\n/**\n   * 1. Correct the inheritance and scaling of font size in all browsers.\n   * 2. Correct the odd `em` font sizing in all browsers.\n   */\n\npre {\n  font-family: monospace, monospace; /* 1 */\n  font-size: 1em; /* 2 */\n}\n\n/* Text-level semantics\n     ========================================================================== */\n\n/**\n   * Remove the gray background on active links in IE 10.\n   */\n\na {\n  background-color: transparent;\n}\n\n/**\n   * 1. Remove the bottom border in Chrome 57-\n   * 2. Add the correct text decoration in Chrome, Edge, IE, Opera, and Safari.\n   */\n\nabbr[title] {\n  border-bottom: none; /* 1 */\n  text-decoration: underline; /* 2 */\n  -webkit-text-decoration: underline dotted;\n          text-decoration: underline dotted; /* 2 */\n}\n\n/**\n   * Add the correct font weight in Chrome, Edge, and Safari.\n   */\n\nb,\nstrong {\n  font-weight: bolder;\n}\n\n/**\n   * 1. Correct the inheritance and scaling of font size in all browsers.\n   * 2. Correct the odd `em` font sizing in all browsers.\n   */\n\ncode,\nkbd,\nsamp {\n  font-family: monospace, monospace; /* 1 */\n  font-size: 1em; /* 2 */\n}\n\n/**\n   * Add the correct font size in all browsers.\n   */\n\nsmall {\n  font-size: 80%;\n}\n\n/**\n   * Prevent `sub` and `sup` elements from affecting the line height in\n   * all browsers.\n   */\n\nsub,\nsup {\n  font-size: 75%;\n  line-height: 0;\n  position: relative;\n  vertical-align: baseline;\n}\n\nsub {\n  bottom: -0.25em;\n}\n\nsup {\n  top: -0.5em;\n}\n\n/* Embedded content\n     ========================================================================== */\n\n/**\n   * Remove the border on images inside links in IE 10.\n   */\n\nimg {\n  border-style: none;\n}\n\n/* Forms\n     ========================================================================== */\n\n/**\n   * 1. Change the font styles in all browsers.\n   * 2. Remove the margin in Firefox and Safari.\n   */\n\nbutton,\ninput,\noptgroup,\nselect,\ntextarea {\n  font-family: inherit; /* 1 */\n  font-size: 100%; /* 1 */\n  line-height: 1.15; /* 1 */\n  margin: 0; /* 2 */\n}\n\n/**\n   * Show the overflow in IE.\n   * 1. Show the overflow in Edge.\n   */\n\nbutton,\ninput {\n  /* 1 */\n  overflow: visible;\n}\n\n/**\n   * Remove the inheritance of text transform in Edge, Firefox, and IE.\n   * 1. Remove the inheritance of text transform in Firefox.\n   */\n\nbutton,\nselect {\n  /* 1 */\n  text-transform: none;\n}\n\n/**\n   * Correct the inability to style clickable types in iOS and Safari.\n   */\n\nbutton,\n[type=\"button\"],\n[type=\"reset\"],\n[type=\"submit\"] {\n  -webkit-appearance: button;\n}\n\n/**\n   * Remove the inner border and padding in Firefox.\n   */\n\nbutton::-moz-focus-inner,\n[type=\"button\"]::-moz-focus-inner,\n[type=\"reset\"]::-moz-focus-inner,\n[type=\"submit\"]::-moz-focus-inner {\n  border-style: none;\n  padding: 0;\n}\n\n/**\n   * Restore the focus styles unset by the previous rule.\n   */\n\nbutton:-moz-focusring,\n[type=\"button\"]:-moz-focusring,\n[type=\"reset\"]:-moz-focusring,\n[type=\"submit\"]:-moz-focusring {\n  outline: 1px dotted ButtonText;\n}\n\n/**\n   * Correct the padding in Firefox.\n   */\n\nfieldset {\n  padding: 0.35em 0.75em 0.625em;\n}\n\n/**\n   * 1. Correct the text wrapping in Edge and IE.\n   * 2. Correct the color inheritance from `fieldset` elements in IE.\n   * 3. Remove the padding so developers are not caught out when they zero out\n   *    `fieldset` elements in all browsers.\n   */\n\nlegend {\n  box-sizing: border-box; /* 1 */\n  color: inherit; /* 2 */\n  display: table; /* 1 */\n  max-width: 100%; /* 1 */\n  padding: 0; /* 3 */\n  white-space: normal; /* 1 */\n}\n\n/**\n   * Add the correct vertical alignment in Chrome, Firefox, and Opera.\n   */\n\nprogress {\n  vertical-align: baseline;\n}\n\n/**\n   * Remove the default vertical scrollbar in IE 10+.\n   */\n\ntextarea {\n  overflow: auto;\n}\n\n/**\n   * 1. Add the correct box sizing in IE 10.\n   * 2. Remove the padding in IE 10.\n   */\n\n[type=\"checkbox\"],\n[type=\"radio\"] {\n  box-sizing: border-box; /* 1 */\n  padding: 0; /* 2 */\n}\n\n/**\n   * Correct the cursor style of increment and decrement buttons in Chrome.\n   */\n\n[type=\"number\"]::-webkit-inner-spin-button,\n[type=\"number\"]::-webkit-outer-spin-button {\n  height: auto;\n}\n\n/**\n   * 1. Correct the odd appearance in Chrome and Safari.\n   * 2. Correct the outline style in Safari.\n   */\n\n[type=\"search\"] {\n  -webkit-appearance: textfield; /* 1 */\n  outline-offset: -2px; /* 2 */\n}\n\n/**\n   * Remove the inner padding in Chrome and Safari on macOS.\n   */\n\n[type=\"search\"]::-webkit-search-decoration {\n  -webkit-appearance: none;\n}\n\n/**\n   * 1. Correct the inability to style clickable types in iOS and Safari.\n   * 2. Change font properties to `inherit` in Safari.\n   */\n\n::-webkit-file-upload-button {\n  -webkit-appearance: button; /* 1 */\n  font: inherit; /* 2 */\n}\n\n/* Interactive\n     ========================================================================== */\n\n/*\n   * Add the correct display in Edge, IE 10+, and Firefox.\n   */\n\ndetails {\n  display: block;\n}\n\n/*\n   * Add the correct display in all browsers.\n   */\n\nsummary {\n  display: list-item;\n}\n\n/* Misc\n     ========================================================================== */\n\n/**\n   * Add the correct display in IE 10+.\n   */\n\ntemplate {\n  display: none;\n}\n\n/**\n   * Add the correct display in IE 10.\n   */\n\n[hidden] {\n  display: none;\n}\n\nhtml,\nbody,\ndiv,\nspan,\napplet,\nobject,\niframe,\nh1,\nh2,\nh3,\nh4,\nh5,\nh6,\np,\nblockquote,\npre,\na,\nabbr,\nacronym,\naddress,\nbig,\ncite,\ncode,\ndel,\ndfn,\nem,\nimg,\nins,\nkbd,\nq,\ns,\nsamp,\nsmall,\nstrike,\nstrong,\nsub,\nsup,\ntt,\nvar,\nb,\nu,\ni,\ncenter,\ndl,\ndt,\ndd,\nol,\nul,\nli,\nfieldset,\nform,\nlabel,\nlegend,\ntable,\ncaption,\ntbody,\ntfoot,\nthead,\ntr,\nth,\ntd,\narticle,\naside,\ncanvas,\ndetails,\nembed,\nfigure,\nfigcaption,\nfooter,\nheader,\nhgroup,\nmenu,\nnav,\noutput,\nruby,\nsection,\nsummary,\ntime,\nmark,\naudio,\nvideo {\n  margin: 0;\n  padding: 0;\n  border: 0;\n  font-size: 100%;\n  font-style: inherit;\n  vertical-align: baseline;\n}\n\n\n:host {\n  display: flex;\n}\n\na {\n  text-decoration: none !important;\n  color: var(--ic-card-text-primary) !important;\n}\n\na:visited {\n  color: var(--ic-card-link-action-dark) !important;\n}\n\nbutton {\n  border: none;\n  background-color: transparent;\n  outline: var(--ic-hc-focus-outline);\n}\n\n.card {\n  display: flex;\n  flex-direction: column;\n  border: var(--ic-space-1px) solid var(--ic-card-border-primary);\n  border-radius: var(--ic-border-radius);\n  box-sizing: border-box;\n  padding: var(--ic-space-md);\n  text-align: left;\n  color: var(--ic-card-text-primary);\n  transition: var(--ic-easing-transition-fast);\n  position: relative;\n  width: inherit;\n  min-width: -moz-fit-content;\n  min-width: fit-content;\n  height: -moz-fit-content;\n  height: fit-content;\n  min-height: 100%;\n\n  ::slotted(svg) {\n    fill: var(--ic-card-icon);\n  }\n\n  &.monochrome {\n    border: var(--ic-border-width) solid var(--ic-card-border-monochrome);\n  }\n\n  &.fullwidth {\n    width: 100%;\n  }\n\n  &.clickable {\n    &:hover {\n      background-color: var(--ic-card-background-hover);\n      border: var(--ic-space-1px) solid var(--ic-card-hover-border-color);\n      cursor: pointer;\n    }\n\n    &.focussed,\n    &:focus {\n      background-color: var(--ic-card-background-hover);\n      box-shadow: var(--ic-border-focus);\n      outline: var(--ic-hc-focus-outline);\n      border: var(--ic-space-1px) solid var(--ic-card-pressed-border-color);\n    }\n\n    &:active {\n      background-color: var(--ic-card-background-pressed);\n      box-shadow: var(--ic-border-focus);\n      .card-title {\n        text-decoration: none;\n      }\n    }\n\n    .card-title {\n      --ic-typography-color: var(--ic-card-clickable-text);\n      color: var(--ic-card-clickable-text);\n      text-decoration: underline;\n      text-decoration-thickness: var(--ic-space-1px);\n      margin-bottom: var(--ic-space-xxs);\n    }\n    .interaction-button,\n    .icon {\n      margin-bottom: var(--ic-space-xxs);\n    }\n  }\n\n  &.disabled {\n    border: var(--ic-space-1px) dashed var(--ic-card-disabled-border-color);\n\n    .card-message,\n    .subheading,\n    .card-title {\n      --ic-typography-color: var(--ic-card-disabled-text);\n    }\n\n    .card-title {\n      text-decoration: underline;\n      text-decoration-thickness: var(--ic-space-1px);\n      text-decoration-color: var(--ic-card-disabled-text);\n      color: var(--ic-card-disabled-text);\n    }\n\n    ::slotted(svg) {\n      fill: var(--ic-card-icon-disabled);\n    }\n  }\n}\n\n.card-header {\n  display: flex;\n  align-items: center;\n}\n\n.icon {\n  display: flex;\n  align-items: center;\n  padding-right: var(--ic-space-xs);\n}\n\n.card.clickable:hover .card-title,\n.card.clickable:focus .card-title,\n.card.clickable.focussed .card-title {\n  display: inline-block;\n  border-bottom: 0.25rem solid !important;\n  margin-bottom: 0 !important;\n  text-decoration: none;\n}\n\n@supports (text-underline-offset: 25%) {\n  .card.clickable:hover .card-title,\n  .card.clickable:focus .card-title,\n  .card.clickable.focussed .card-title {\n    text-decoration-line: underline;\n    text-decoration-thickness: 25%;\n    text-underline-offset: 25%;\n    border-bottom: 0 !important;\n    margin-bottom: 0.25rem !important;\n  }\n}\n\n.subheading {\n  margin-top: var(--ic-space-xxs);\n}\n\n.adornment {\n  margin-top: var(--ic-space-xxs);\n}\n\n.card-message {\n  margin-top: var(--ic-space-md);\n  align-items: left;\n}\n\n.interaction-button {\n  margin-left: auto;\n}\n\n.image-top {\n  margin-bottom: var(--ic-space-md);\n  display: flex;\n  justify-content: center;\n}\n\n.image-mid {\n  margin-top: var(--ic-space-md);\n  display: flex;\n  justify-content: center;\n}\n\n.interaction-area {\n  display: flex;\n  flex-grow: 1;\n  gap: var(--ic-space-md);\n  margin-top: var(--ic-space-md);\n  align-items: flex-end;\n}\n\n.interaction-controls {\n  display: flex;\n  align-items: center;\n  flex-wrap: wrap;\n  gap: var(--ic-space-sm);\n}\n\n.toggle-button {\n  width: 2.5rem;\n  height: 2.5rem;\n  padding: var(--ic-space-xs);\n  margin: var(--ic-space-1px) 0;\n  min-width: 0;\n  cursor: pointer;\n  transition: var(--ic-easing-transition-fast);\n  border-radius: var(--ic-border-radius);\n  display: inline-flex;\n  flex-direction: row;\n  justify-content: center;\n  align-items: center;\n  background: none;\n  border: none;\n  box-sizing: border-box;\n  white-space: nowrap;\n  vertical-align: middle;\n\n  &:hover {\n    background-color: var(--ic-card-background-hover);\n  }\n\n  &:focus {\n    box-shadow: var(--ic-border-focus);\n  }\n\n  &:active:not(:focus) {\n    background-color: var(--ic-card-background-pressed);\n  }\n\n  svg {\n    pointer-events: none;\n    width: 100% !important;\n    height: 100% !important;\n    fill: currentcolor !important;\n  }\n}\n\n#ic-tooltip-expand-button {\n  margin-left: auto;\n  position: relative;\n}\n\n.toggle-button-closed svg {\n  transform: rotate(90deg);\n}\n\n.toggle-button-expanded svg {\n  transform: rotate(-90deg);\n}\n\n.expanded-content {\n  margin-top: var(--ic-space-md);\n}\n\n/** High Contrast **/\n@media (forced-colors: active) {\n  .card {\n    ::slotted(svg) {\n      fill: currentcolor;\n    }\n\n    &.disabled {\n      border-color: GrayText !important;\n\n      ::slotted(svg) {\n        fill: GrayText !important;\n      }\n\n      .card-message,\n      .subheading,\n      .card-title {\n        color: GrayText;\n\n        --ic-typography-color: GrayText;\n      }\n    }\n  }\n\n  .toggle-button:focus,\n  .toggle-button:hover {\n    outline-color: Highlight;\n  }\n}\n";
const IcCardVerticalStyle0 = icCardVerticalCss;

const CardVertical = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.hostMutationObserver = null;
        this.areaExpanded = false;
        this.isFocussed = false;
        this.monochrome = false;
        this.parentEl = null;
        this.parentIsAnchorTag = false;
        /**
         * If `true`, the card will be a clickable variant, instead of static.
         */
        this.clickable = false;
        /**
         * If `true`, the card will be disabled if it is clickable.
         */
        this.disabled = false;
        /**
         *  If `true`, the card will have an expandable area and expansion toggle button.
         */
        this.expandable = false;
        /**
         *  If `true`, the card will fill the width of the container.
         */
        this.fullWidth = false;
        /**
         * The human language of the linked URL.
         */
        this.hreflang = "";
        /**
         * The main body message of the card.
         */
        this.message = "";
        /**
         * Sets the theme color to the dark or light theme color. "inherit" will set the color based on the system settings or ic-theme component.
         */
        this.theme = "inherit";
        this.parentFocussed = () => {
            this.isFocussed = true;
        };
        this.parentBlurred = () => {
            this.isFocussed = false;
        };
        this.toggleExpanded = () => {
            this.areaExpanded = !this.areaExpanded;
        };
    }
    watchDisabledHandler() {
        helpers.removeDisabledFalse(this.disabled, this.el);
    }
    disconnectedCallback() {
        var _a;
        if (this.parentEl && this.parentIsAnchorTag) {
            this.parentEl.removeEventListener("focus", this.parentFocussed);
            this.parentEl.removeEventListener("blur", this.parentBlurred);
        }
        (_a = this.hostMutationObserver) === null || _a === void 0 ? void 0 : _a.disconnect();
    }
    componentWillLoad() {
        var _a;
        this.parentEl = this.el.parentElement;
        if (((_a = this.parentEl) === null || _a === void 0 ? void 0 : _a.tagName) === "A") {
            this.clickable = true;
            this.parentIsAnchorTag = true;
            this.parentEl.classList.add("ic-card-wrapper-link");
            this.parentEl.addEventListener("focus", this.parentFocussed);
            this.parentEl.addEventListener("blur", this.parentBlurred);
        }
        helpers.removeDisabledFalse(this.disabled, this.el);
    }
    componentDidLoad() {
        !helpers.isSlotUsed(this.el, "heading") &&
            helpers.onComponentRequiredPropUndefined([{ prop: this.heading, propName: "heading" }], "Card");
        this.updateTheme();
        this.hostMutationObserver = new MutationObserver((mutationList) => helpers.renderDynamicChildSlots(mutationList, [
            "message",
            "adornment",
            "expanded-content",
            "image-top",
            "image-mid",
            "icon",
            "interaction-button",
            "badge",
            "interaction-controls",
        ], this));
        this.hostMutationObserver.observe(this.el, {
            childList: true,
        });
    }
    handleHostClick(event) {
        if (this.disabled) {
            event.stopImmediatePropagation();
        }
    }
    brandChangeHandler(ev) {
        this.updateTheme(ev.detail.mode);
    }
    /**
     * Sets focus on the card.
     */
    async setFocus() {
        var _a, _b;
        const shadowRoot = this.el.shadowRoot;
        if (shadowRoot) {
            if (shadowRoot.querySelector("a")) {
                (_a = shadowRoot.querySelector("a")) === null || _a === void 0 ? void 0 : _a.focus();
            }
            else if (shadowRoot.querySelector("button")) {
                (_b = shadowRoot.querySelector("button")) === null || _b === void 0 ? void 0 : _b.focus();
            }
        }
    }
    updateTheme(mode = null) {
        const foregroundColor = helpers.getBrandFromContext(this.el, mode);
        if (foregroundColor !== helpers.IcBrandForegroundEnum.Default) {
            this.monochrome = true;
            this.theme =
                foregroundColor === helpers.IcBrandForegroundEnum.Light
                    ? helpers.IcBrandForegroundEnum.Dark
                    : helpers.IcBrandForegroundEnum.Light;
        }
    }
    render() {
        const { clickable, disabled, expandable, fullWidth, heading, isFocussed, message, monochrome, href, hreflang, parentIsAnchorTag, referrerpolicy, rel, subheading, target, theme, } = this;
        const Component = parentIsAnchorTag || !clickable
            ? "div"
            : href === undefined
                ? "button"
                : "a";
        const attrs = Component == "a" && {
            href: href,
            hrefLang: hreflang,
            referrerPolicy: referrerpolicy,
            rel: rel,
            target: target,
        };
        return (index.h(index.Host, { key: 'd62f341e096d81fa917e578aa55c99d6d828c9e3', class: {
                [`ic-theme-${theme}`]: theme !== "inherit",
            } }, index.h(Component, Object.assign({ key: '742b03d9281d850a9052638038980b45ca567c17', class: {
                card: true,
                clickable: !!clickable && !disabled,
                disabled: !!disabled,
                fullwidth: !!fullWidth,
                focussed: isFocussed,
                monochrome: monochrome,
            }, tabindex: clickable && !parentIsAnchorTag ? 0 : undefined, "aria-disabled": disabled ? "true" : null, disabled: disabled }, attrs), helpers.isSlotUsed(this.el, "image-top") && (index.h("div", { key: 'd5f584871df498cf11acb97ff3694115d4819a73', class: "image-top" }, index.h("slot", { key: '88fa5d9566421a5ca724622bb11b0ad593babecb', name: "image-top" }))), index.h("div", { key: '3211c93ebca0fcddad4ac7ce75999ab8d7939442', class: "card-header" }, helpers.isSlotUsed(this.el, "icon") && (index.h("div", { key: 'c80cf3c24f0cbdf7cac901ee8c945c4d1432fe9f', class: "icon" }, index.h("slot", { key: '7e087604510f545b891f104f972ee50ac686b9be', name: "icon" }))), index.h("div", { key: '02bc7be8d85faee7b497c2b2608d80f70b79ec86', class: "card-title" }, index.h("slot", { key: 'e5285ad53121d899dd27966860b664fe1ecc388f', name: "heading" }, index.h("ic-typography", { key: '00573eddbbdd537b86a1331bd2b2db4a443a13c0', variant: "h4" }, index.h("p", { key: 'bccc52bc8feadd3abe0cd8092819258dc2e155c8' }, heading)))), helpers.isSlotUsed(this.el, "interaction-button") && (index.h("div", { key: 'f9f2baeee122976ab5ffa8e3dff9027bb78db6b4', class: "interaction-button" }, index.h("slot", { key: '01b087c7b7ff9fa54dfb1171c5a4899cf090b45c', name: "interaction-button" })))), (subheading || helpers.isSlotUsed(this.el, "subheading")) && (index.h("div", { key: '81f19c8c0d726ebbb35f71375a35fac342e4e7cd', class: "subheading" }, index.h("slot", { key: '17c871d9694857824afb3c9f7593c8498873d810', name: "subheading" }, index.h("ic-typography", { key: '9ca1068e95a3c69def8ec0bf82135dd36ed57fbc', variant: "subtitle-small" }, subheading)))), helpers.isSlotUsed(this.el, "adornment") && (index.h("div", { key: 'e43dadfb629c3a5dd28a6b1c46555dfade8d498f', class: "adornment" }, index.h("slot", { key: 'b8f63d79ffaff166020d643497ad8b92f4580a0e', name: "adornment" }))), helpers.isSlotUsed(this.el, "image-mid") && (index.h("div", { key: '1077bd869310c629a1b154e031dbed14559798b7', class: "image-mid" }, index.h("slot", { key: 'f598c5ddfb5a591f3988c49b3f7be1e84fb87552', name: "image-mid" }))), (message || helpers.isSlotUsed(this.el, "message")) && (index.h("div", { key: '08d46a26aac3972495cc7724ff8fbd55cc90a31c', class: "card-message" }, message && (index.h("ic-typography", { key: '50c632b1ac9fed137e668ceec4f1fe35f9a2cf99', variant: "body" }, message)), helpers.isSlotUsed(this.el, "message") && index.h("slot", { key: '2b971484237d985d4318993477d39b5f6d1e8f0d', name: "message" }))), (helpers.isSlotUsed(this.el, "interaction-controls") || expandable) && (index.h("div", { key: '3e7f6bc8df858349187486fb9e9ebec56d42d0a5', class: "interaction-area" }, index.h("div", { key: '4fd96e05aa6daef84d93d8f1da4dd80b2d349623', class: "interaction-controls" }, index.h("slot", { key: '2f690307f464bb1f710344723b2f76078334ea30', name: "interaction-controls" })), expandable && (index.h("ic-tooltip", { key: '9880fae8f9a52bdfe1820df5cbfc92af33080e2a', id: "ic-tooltip-expand-button", label: "Toggle expandable area", silent: true }, index.h("button", { key: '0d1656a001fa061ebae17757a560ba11dae90339', class: {
                "toggle-button": true,
                [`toggle-button-${this.areaExpanded ? "expanded" : "closed"}`]: true,
            }, "aria-label": "Toggle expandable area", "aria-expanded": `${this.areaExpanded}`, "aria-controls": this.areaExpanded ? "expanded-content-area" : null, onClick: this.toggleExpanded, innerHTML: chevronIcon.Chevron }))))), helpers.isSlotUsed(this.el, "expanded-content") && this.areaExpanded && (index.h("div", { key: 'dc55cb4419b35c1f5f6b771cf5dc62c1d77626a7', class: "expanded-content", id: "expanded-content-area" }, index.h("slot", { key: '3b0d0c87d0467ffde6e62ed49b9116280a6c7108', name: "expanded-content" }))), helpers.isSlotUsed(this.el, "badge") && index.h("slot", { key: 'f51d29f2b88429b0e0024c6f9ba34abaf4e1a6d1', name: "badge" }))));
    }
    get el() { return index.getElement(this); }
    static get watchers() { return {
        "disabled": ["watchDisabledHandler"]
    }; }
};
CardVertical.style = IcCardVerticalStyle0;

exports.ic_card_vertical = CardVertical;

//# sourceMappingURL=ic-card-vertical.cjs.entry.js.map