import { Host, h } from "@stencil/core";
export class SectionContainer {
    constructor() {
        /**
         * The alignment of the container.
         */
        this.aligned = "left";
        /**
         * If `true`, the standard vertical padding from the container will be removed.
         */
        this.fullHeight = false;
    }
    render() {
        const { aligned, fullHeight } = this;
        return (h(Host, { key: '67c1b4b2afe62fc53812421ee49c01bf689e05b4', class: {
                ["aligned-left"]: aligned === "left" || aligned === null,
                ["aligned-center"]: aligned === "center",
                ["aligned-full-width"]: aligned === "full-width",
                ["no-vertical-padding"]: !!fullHeight,
            } }, h("slot", { key: 'cb21cb372b6131cfb990ac0a016f6c64641749f9' })));
    }
    static get is() { return "ic-section-container"; }
    static get encapsulation() { return "shadow"; }
    static get originalStyleUrls() {
        return {
            "$": ["ic-section-container.css"]
        };
    }
    static get styleUrls() {
        return {
            "$": ["ic-section-container.css"]
        };
    }
    static get properties() {
        return {
            "aligned": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "IcAlignment",
                    "resolved": "\"center\" | \"full-width\" | \"left\" | undefined",
                    "references": {
                        "IcAlignment": {
                            "location": "import",
                            "path": "../../utils/types",
                            "id": "src/utils/types.ts::IcAlignment"
                        }
                    }
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": "The alignment of the container."
                },
                "getter": false,
                "setter": false,
                "attribute": "aligned",
                "reflect": false,
                "defaultValue": "\"left\""
            },
            "fullHeight": {
                "type": "boolean",
                "mutable": false,
                "complexType": {
                    "original": "boolean",
                    "resolved": "boolean | undefined",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [],
                    "text": "If `true`, the standard vertical padding from the container will be removed."
                },
                "getter": false,
                "setter": false,
                "attribute": "full-height",
                "reflect": false,
                "defaultValue": "false"
            }
        };
    }
}
//# sourceMappingURL=ic-section-container.js.map
