import { proxyCustomElement, HTMLElement, createEvent, h, Host } from '@stencil/core/internal/client';
import { r as removeDisabledFalse, s as removeFormResetListener, i as isSlotUsed, q as addFormResetListener, o as onComponentRequiredPropUndefined, E as slotHasContent, l as isPropDefined } from './helpers.js';
import { d as defineCustomElement$2 } from './ic-typography2.js';

const icRadioOptionCss = "/*! normalize.css v8.0.1 | MIT License | github.com/necolas/normalize.css */html{line-height:1.15;-webkit-text-size-adjust:100%;}body{margin:0}main{display:block}h1{font-size:2em;margin:0.67em 0}hr{box-sizing:content-box;height:0;overflow:visible;}pre{font-family:monospace, monospace;font-size:1em;}a{background-color:transparent}abbr[title]{border-bottom:none;text-decoration:underline;-webkit-text-decoration:underline dotted;text-decoration:underline dotted;}b,strong{font-weight:bolder}code,kbd,samp{font-family:monospace, monospace;font-size:1em;}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-0.25em}sup{top:-0.5em}img{border-style:none}button,input,optgroup,select,textarea{font-family:inherit;font-size:100%;line-height:1.15;margin:0;}button,input{overflow:visible}button,select{text-transform:none}button,[type=\"button\"],[type=\"reset\"],[type=\"submit\"]{-webkit-appearance:button}button::-moz-focus-inner,[type=\"button\"]::-moz-focus-inner,[type=\"reset\"]::-moz-focus-inner,[type=\"submit\"]::-moz-focus-inner{border-style:none;padding:0}button:-moz-focusring,[type=\"button\"]:-moz-focusring,[type=\"reset\"]:-moz-focusring,[type=\"submit\"]:-moz-focusring{outline:1px dotted ButtonText}fieldset{padding:0.35em 0.75em 0.625em}legend{box-sizing:border-box;color:inherit;display:table;max-width:100%;padding:0;white-space:normal;}progress{vertical-align:baseline}textarea{overflow:auto}[type=\"checkbox\"],[type=\"radio\"]{box-sizing:border-box;padding:0;}[type=\"number\"]::-webkit-inner-spin-button,[type=\"number\"]::-webkit-outer-spin-button{height:auto}[type=\"search\"]{-webkit-appearance:textfield;outline-offset:-2px;}[type=\"search\"]::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit;}details{display:block}summary{display:list-item}template{display:none}[hidden]{display:none}html,body,div,span,applet,object,iframe,h1,h2,h3,h4,h5,h6,p,blockquote,pre,a,abbr,acronym,address,big,cite,code,del,dfn,em,img,ins,kbd,q,s,samp,small,strike,strong,sub,sup,tt,var,b,u,i,center,dl,dt,dd,ol,ul,li,fieldset,form,label,legend,table,caption,tbody,tfoot,thead,tr,th,td,article,aside,canvas,details,embed,figure,figcaption,footer,header,hgroup,menu,nav,output,ruby,section,summary,time,mark,audio,video{margin:0;padding:0;border:0;font-size:100%;font-style:inherit;vertical-align:baseline}ic-radio-option{display:flex;flex-direction:column;width:-moz-fit-content;width:fit-content}.additional-field-wrapper [slot=\"additional-field\"]{margin-top:calc(var(--ic-space-sm) / 2);margin-left:var(--ic-space-xl)}ic-radio-option.ic-radio-option-disabled,ic-radio-option.ic-radio-option-disabled .radio-label{--ic-typography-color:var(--ic-radio-button-text-option-disabled)}.container input:focus+span.checkmark,.container:hover input:focus+span.checkmark,.container:active input:focus+span.checkmark,:host(:focus) .container input:checked+span.checkmark{box-shadow:var(--ic-border-focus)}.container{display:grid;grid-template-columns:min-content auto;position:relative;cursor:pointer;align-items:center;margin:var(--ic-space-xxs) 0 var(--ic-space-xxs) var(--ic-space-xxs)}.container.disabled,.container.disabled input:disabled{cursor:default}.container input{-webkit-appearance:none;-moz-appearance:none;appearance:none;display:inline-block;position:absolute;cursor:pointer;height:var(--ic-space-lg);width:var(--ic-space-lg);border-radius:50%;border:none}.checkmark{display:block;position:relative;top:0;left:0;height:var(--ic-space-lg);width:var(--ic-space-lg);background-color:var(--ic-radio-button-background-default);border:var(--ic-space-1px) solid var(--ic-radio-button-border-default);border-radius:50%;transition:var(--ic-easing-transition-fast);box-sizing:border-box}.container input:checked~.checkmark::after{display:inline-block}.container:hover input~.checkmark{box-shadow:0 0 0 0.25rem var(--ic-radio-button-active-hover);border:var(--ic-border-width) solid var(--ic-radio-button-default-hover)}.container:hover input:checked~.checkmark{box-shadow:0 0 0 0.25rem var(--ic-radio-button-active-hover);border:0.125rem solid var(--ic-radio-button-default-hover)}.container:hover:not(.disabled) input:checked~.checkmark::after{background-color:var(--ic-radio-button-default-hover)}.container:active input~.checkmark{box-shadow:0 0 0 0.25rem var(--ic-radio-button-active-pressed);border:var(--ic-border-width) solid var(--ic-radio-button-default-pressed)}.container:active input:checked~.checkmark{border:0.125rem solid var(--ic-radio-button-default-pressed);box-shadow:0 0 0 0.25rem var(--ic-radio-button-active-pressed)}.container:active input:checked~.checkmark::after{background-color:var(--ic-radio-button-default-pressed)}.container input:checked~.checkmark{border:0.125rem solid var(--ic-radio-button-default-active)}.container input:checked:disabled~.checkmark{border:0.125rem solid var(--ic-radio-button-border-disabled)}.container input:disabled~.checkmark{border:var(--ic-border-width) dashed var(--ic-radio-button-border-disabled)}.container input:disabled~.checkmark::after{background:var(--ic-radio-button-disabled)}.container:hover input:disabled~.checkmark{box-shadow:none;border:0.125rem solid none}.container:active input:disabled~.checkmark::after{background-color:var(--ic-radio-button-disabled)}.container .checkmark::after{content:\"\";position:absolute;display:none;top:calc(50% - var(--ic-space-xs));left:calc(50% - var(--ic-space-xs));width:var(--ic-space-md);height:var(--ic-space-md);border-radius:50%;background:var(--ic-radio-button-default-active)}.radio-label{margin-left:var(--ic-space-md);--ic-typography-color:var(--ic-radio-button-text-option)}.additional-field-wrapper{margin-left:var(--ic-space-xs)}.branch-corner{color:var(--ic-radio-button-required-bar);height:var(--ic-space-md);width:var(--ic-space-xl);border-radius:0 0 0 0.188rem;border-bottom:0.125rem solid var(--ic-radio-button-required-bar);border-left:0.125rem solid var(--ic-radio-button-required-bar);margin-left:calc(-1 * var(--ic-space-1px))}.dynamic-container{display:flex;position:relative;margin:var(--ic-space-xxxs) 0 var(--ic-space-xxs) var(--ic-space-md);gap:var(--ic-space-xs)}.dynamic-container.hidden{display:none}.dynamic-text{color:var(--ic-radio-button-required-text);--ic-typography-color:var(--ic-radio-button-required-text);margin-top:calc(var(--ic-space-sm) / 2);margin-bottom:var(--ic-space-xs);border-radius:2%}@media (max-width: 576px){ic-text-field{--input-width:100%}}@media (forced-colors: active){.container input:checked~.checkmark,.container:active input:checked~.checkmark{border-color:Highlight}.container input:checked~.checkmark::after,.container:active input:checked~.checkmark::after{background-color:Highlight}.container input:disabled~.checkmark,.container input:checked:disabled~.checkmark{border-color:GrayText}.container input:disabled~.checkmark::after,.container:active input:disabled~.checkmark::after{background-color:GrayText}}input[type=\"radio\"]:dir(rtl){right:0}.radio-label:dir(rtl){padding-right:var(--ic-space-sm);padding-left:0}.branch-corner:dir(rtl){border-radius:0 0 0.188rem;border-right:0.125rem solid var(--ic-action-default);border-left:none}.dynamic-container:dir(rtl){margin:var(--ic-space-xxxs) var(--ic-space-sm) var(--ic-space-xxs) 0}";
const IcRadioOptionStyle0 = icRadioOptionCss;

const ADDITIONAL_FIELD = "additional-field";
const RadioOption = /*@__PURE__*/ proxyCustomElement(class RadioOption extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.icCheck = createEvent(this, "icCheck", 7);
        this.icSelectedChange = createEvent(this, "icSelectedChange", 7);
        this.defaultRadioValue = "";
        this.hasAdditionalField = false;
        this.skipFocus = false;
        /**
         * The style of additionalField that will be displayed if used.
         */
        this.additionalFieldDisplay = "static";
        /**
         * If `true`, the disabled state will be set.
         */
        this.disabled = false;
        /**
         * The text to be displayed when dynamic.
         */
        this.dynamicText = "This selection requires additional answers";
        /**
         * Sets the theme color to the dark or light theme color. "inherit" will set the color based on the system settings or ic-theme component.
         */
        this.theme = "inherit";
        /**
         * If `true`, the radio option will be displayed in a selected state.
         */
        this.selected = false;
        this.initiallySelected = this.selected;
        this.handleClick = (event) => {
            var _a, _b;
            const clickedAdditionalField = event.target.matches(".dynamic-container:not(ic-radio-option, .checkmark), .dynamic-container *:not(ic-radio-option, .checkmark)");
            if (!this.disabled &&
                (!clickedAdditionalField || event.target === this.radioElement)) {
                event.stopPropagation();
                if (this.skipFocus === false) {
                    (_a = this.radioElement) === null || _a === void 0 ? void 0 : _a.focus();
                }
                this.skipFocus = false;
                if (this.hasAdditionalField) {
                    this.value = ((_b = this.getAdditionalField()) === null || _b === void 0 ? void 0 : _b.value) || this.defaultRadioValue;
                }
                this.icCheck.emit({
                    value: this.value,
                });
            }
        };
        this.handleKeyDown = (event) => {
            const preventPropagationElements = ["IC-DATE-INPUT", "IC-DATE-PICKER"];
            if (this.getAdditionalField() == document.activeElement &&
                preventPropagationElements.includes(this.getAdditionalField().nodeName)) {
                event.stopPropagation();
            }
        };
        this.handleFormReset = () => {
            this.skipFocus = true;
            this.selected = this.initiallySelected;
        };
    }
    watchDisabledHandler() {
        removeDisabledFalse(this.disabled, this.el);
    }
    watchSelectedHandler() {
        this.icSelectedChange.emit();
    }
    handleCheck(ev) {
        if (this.additionalFieldDisplay === "static" &&
            Array.from(this.el.querySelectorAll("ic-radio-option")).includes(ev.target))
            this.icCheck.emit({ value: this.value });
    }
    disconnectedCallback() {
        removeFormResetListener(this.el, this.handleFormReset);
    }
    componentWillLoad() {
        if (isSlotUsed(this.el, ADDITIONAL_FIELD)) {
            this.hasAdditionalField = true;
            this.getAdditionalField();
        }
        this.defaultRadioValue = this.value;
        addFormResetListener(this.el, this.handleFormReset);
        removeDisabledFalse(this.disabled, this.el);
    }
    componentDidLoad() {
        onComponentRequiredPropUndefined([{ prop: this.value, propName: "value" }], "Radio Option");
    }
    componentWillRender() {
        const hasSlot = slotHasContent(this.el, ADDITIONAL_FIELD);
        if (hasSlot && !this.hasAdditionalField) {
            this.hasAdditionalField = true;
            this.getAdditionalField();
        }
        else if (!hasSlot && this.hasAdditionalField) {
            this.hasAdditionalField = false;
        }
    }
    componentDidRender() {
        if (this.additionalFieldDisplay === "static") {
            const additionalField = this.getAdditionalField();
            if (!this.selected || this.disabled) {
                additionalField === null || additionalField === void 0 ? void 0 : additionalField.setAttribute("disabled", "");
            }
            else {
                additionalField === null || additionalField === void 0 ? void 0 : additionalField.removeAttribute("disabled");
            }
        }
    }
    additionalFieldValueHandler(event) {
        if (this.selected) {
            this.value = event.detail.value || this.defaultRadioValue;
            this.icCheck.emit({
                value: this.value,
            });
        }
        event.stopImmediatePropagation();
    }
    /**
     * Sets focus on the radio option.
     */
    async setFocus() {
        var _a;
        (_a = this.radioElement) === null || _a === void 0 ? void 0 : _a.focus();
    }
    /**
     * @internal Sets the tabIndex of the radio option.
     */
    async setTabIndex(value) {
        var _a;
        (_a = this.radioElement) === null || _a === void 0 ? void 0 : _a.setAttribute("tabIndex", value.toString());
    }
    getAdditionalField() {
        const additionalField = this.el.querySelector('ic-text-field[slot="additional-field"]');
        if (additionalField)
            additionalField.hiddenInput = false;
        return additionalField;
    }
    render() {
        const { additionalFieldDisplay, disabled, dynamicText, form, groupLabel, handleClick, handleKeyDown, hasAdditionalField, label, name, selected, value, theme, } = this;
        const id = `ic-radio-option-${isPropDefined(label) || value}-${groupLabel}`;
        return (h(Host, { key: 'd4254c0a08bd7fe373f7beeb849d732d437c6f5b', onClick: handleClick, onKeyDown: handleKeyDown, class: {
                ["ic-radio-option-disabled"]: !!disabled,
                [`ic-theme-${theme}`]: theme !== "inherit",
            } }, h("div", { key: '1b3c7c383278c1d8714f5a7a3a00c8fb780a2931', class: { container: true, disabled: !!disabled } }, h("div", { key: 'ba90a2ce5912981a50d43ebd33086eb227947e5f' }, h("input", { key: '8eb145667ce5b7777ced51480ceebab3f43a7910', tabindex: selected ? "0" : "-1", type: "radio", name: name, id: id, value: value, disabled: disabled, checked: selected, ref: (el) => (this.radioElement = el), form: form }), h("span", { key: '3683fd5eda19dd39f4647a5763705eef4becacb3', class: "checkmark" })), h("ic-typography", { key: 'd662a4e7a5b0ac173a7ea2881d2dac84e94eedc7', class: "radio-label", variant: "body" }, h("label", { key: 'a76e5907c98f2ff18d734167ff69bbe0a1c7ddc4', htmlFor: id }, label))), hasAdditionalField && (h("div", { key: 'ff91776cab766a955e98dee100f73114166fee7a', class: {
                "dynamic-container": true,
                hidden: additionalFieldDisplay === "dynamic" && !selected,
            } }, additionalFieldDisplay === "dynamic" && (h("div", { key: 'e7eeaf7801fd5aa2014edb3796b8b6acc3149b3b', class: "branch-corner" })), h("div", { key: '5cb0e6fca92276f2d2a3bb0f5edc9e4525d44aa2' }, additionalFieldDisplay === "dynamic" && (h("ic-typography", { key: '318ea54a9055f8dde4de2d9802878584d57e186e', variant: "caption" }, h("p", { key: 'e3f34b9536a0f5b95e796c269c586b7905dab59a', class: "dynamic-text" }, dynamicText))), h("div", { key: 'cec5d0147f6f12510e066fff2c0d4d80fe0ee98f', class: {
                "additional-field-wrapper": additionalFieldDisplay === "static",
            } }, h("slot", { key: 'd6279d0506490eceb7d55d6e86609e9e9fb06ea4', name: ADDITIONAL_FIELD })))))));
    }
    get el() { return this; }
    static get watchers() { return {
        "disabled": ["watchDisabledHandler"],
        "selected": ["watchSelectedHandler"]
    }; }
    static get style() { return IcRadioOptionStyle0; }
}, [4, "ic-radio-option", {
        "additionalFieldDisplay": [513, "additional-field-display"],
        "disabled": [4],
        "dynamicText": [1, "dynamic-text"],
        "form": [1],
        "groupLabel": [1, "group-label"],
        "label": [1],
        "name": [1],
        "theme": [1],
        "value": [1025],
        "selected": [1540],
        "initiallySelected": [32],
        "setFocus": [64],
        "setTabIndex": [64]
    }, [[0, "icCheck", "handleCheck"], [0, "icChange", "additionalFieldValueHandler"]], {
        "disabled": ["watchDisabledHandler"],
        "selected": ["watchSelectedHandler"]
    }]);
function defineCustomElement$1() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["ic-radio-option", "ic-typography"];
    components.forEach(tagName => { switch (tagName) {
        case "ic-radio-option":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, RadioOption);
            }
            break;
        case "ic-typography":
            if (!customElements.get(tagName)) {
                defineCustomElement$2();
            }
            break;
    } });
}

const IcRadioOption = RadioOption;
const defineCustomElement = defineCustomElement$1;

export { IcRadioOption, defineCustomElement };

//# sourceMappingURL=ic-radio-option.js.map