import { r as registerInstance, c as createEvent, h, H as Host, g as getElement } from './index-a7a720e7.js';

const icTabPanelCss = "/*! normalize.css v8.0.1 | MIT License | github.com/necolas/normalize.css */html{line-height:1.15;-webkit-text-size-adjust:100%;}body{margin:0}main{display:block}h1{font-size:2em;margin:0.67em 0}hr{box-sizing:content-box;height:0;overflow:visible;}pre{font-family:monospace, monospace;font-size:1em;}a{background-color:transparent}abbr[title]{border-bottom:none;text-decoration:underline;-webkit-text-decoration:underline dotted;text-decoration:underline dotted;}b,strong{font-weight:bolder}code,kbd,samp{font-family:monospace, monospace;font-size:1em;}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-0.25em}sup{top:-0.5em}img{border-style:none}button,input,optgroup,select,textarea{font-family:inherit;font-size:100%;line-height:1.15;margin:0;}button,input{overflow:visible}button,select{text-transform:none}button,[type=\"button\"],[type=\"reset\"],[type=\"submit\"]{-webkit-appearance:button}button::-moz-focus-inner,[type=\"button\"]::-moz-focus-inner,[type=\"reset\"]::-moz-focus-inner,[type=\"submit\"]::-moz-focus-inner{border-style:none;padding:0}button:-moz-focusring,[type=\"button\"]:-moz-focusring,[type=\"reset\"]:-moz-focusring,[type=\"submit\"]:-moz-focusring{outline:1px dotted ButtonText}fieldset{padding:0.35em 0.75em 0.625em}legend{box-sizing:border-box;color:inherit;display:table;max-width:100%;padding:0;white-space:normal;}progress{vertical-align:baseline}textarea{overflow:auto}[type=\"checkbox\"],[type=\"radio\"]{box-sizing:border-box;padding:0;}[type=\"number\"]::-webkit-inner-spin-button,[type=\"number\"]::-webkit-outer-spin-button{height:auto}[type=\"search\"]{-webkit-appearance:textfield;outline-offset:-2px;}[type=\"search\"]::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit;}details{display:block}summary{display:list-item}template{display:none}[hidden]{display:none}html,body,div,span,applet,object,iframe,h1,h2,h3,h4,h5,h6,p,blockquote,pre,a,abbr,acronym,address,big,cite,code,del,dfn,em,img,ins,kbd,q,s,samp,small,strike,strong,sub,sup,tt,var,b,u,i,center,dl,dt,dd,ol,ul,li,fieldset,form,label,legend,table,caption,tbody,tfoot,thead,tr,th,td,article,aside,canvas,details,embed,figure,figcaption,footer,header,hgroup,menu,nav,output,ruby,section,summary,time,mark,audio,video{margin:0;padding:0;border:0;font-size:100%;font-style:inherit;vertical-align:baseline}:host(.ic-tab-panel-hidden){display:none}:host(:not(.ic-tab-panel-hidden)){display:block}:host{color:var(--ic-color-text-primary)}";
const IcTabPanelStyle0 = icTabPanelCss;

const TabPanel = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.tabPanelCreated = createEvent(this, "tabPanelCreated", 7);
        this.tabPanelRemoved = createEvent(this, "tabPanelRemoved", 7);
        /**
         * @internal If `true`, the tab panel will be displayed.
         */
        this.active = false;
        /**
         * @internal Determines whether black variant of the tabs should be displayed.
         */
        this.monochrome = false;
        /** @internal Determines whether the light or dark variant of the tabs should be displayed. */
        this.theme = "inherit";
    }
    connectedCallback() {
        this.tabPanelCreated.emit(this.el);
    }
    render() {
        const { active, theme } = this;
        return (h(Host, { key: '5da4dba2bf404436c8b49173f9056d56912e9049', class: {
                [`ic-theme-${theme}`]: theme !== "inherit",
                "ic-tab-panel-hidden": !active,
            }, role: "tabpanel", "aria-hidden": `${!active}` }, h("div", { key: '9f7b4cbaa9a2c5a72307ca07097cdb50fd93adb2' }, h("slot", { key: 'f97121f2a2d3092c18bd15c82743ba2a988a1134' }))));
    }
    get el() { return getElement(this); }
};
TabPanel.style = IcTabPanelStyle0;

export { TabPanel as ic_tab_panel };

//# sourceMappingURL=ic-tab-panel.entry.js.map