import { r as registerInstance, c as createEvent, f as forceUpdate, h, H as Host, g as getElement } from './index-a7a720e7.js';
import { G as checkSlotInChildMutations, r as removeDisabledFalse, F as debounceEvent, k as removeFormResetListener, x as inheritAttributes, j as addFormResetListener, b as onComponentRequiredPropUndefined, M as IGNORED_KEYBOARD_CHARACTERS, K as IcInformationStatus, n as getInputDescribedByText, l as renderHiddenInput, m as removeHiddenInput, i as isSlotUsed, L as isEmptyString, y as IC_INHERITED_ARIA } from './helpers-f2ffaa7c.js';

const icTextFieldCss = "/*! normalize.css v8.0.1 | MIT License | github.com/necolas/normalize.css */html{line-height:1.15;-webkit-text-size-adjust:100%;}body{margin:0}main{display:block}h1{font-size:2em;margin:0.67em 0}hr{box-sizing:content-box;height:0;overflow:visible;}pre{font-family:monospace, monospace;font-size:1em;}a{background-color:transparent}abbr[title]{border-bottom:none;text-decoration:underline;-webkit-text-decoration:underline dotted;text-decoration:underline dotted;}b,strong{font-weight:bolder}code,kbd,samp{font-family:monospace, monospace;font-size:1em;}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-0.25em}sup{top:-0.5em}img{border-style:none}button,input,optgroup,select,textarea{font-family:inherit;font-size:100%;line-height:1.15;margin:0;}button,input{overflow:visible}button,select{text-transform:none}button,[type=\"button\"],[type=\"reset\"],[type=\"submit\"]{-webkit-appearance:button}button::-moz-focus-inner,[type=\"button\"]::-moz-focus-inner,[type=\"reset\"]::-moz-focus-inner,[type=\"submit\"]::-moz-focus-inner{border-style:none;padding:0}button:-moz-focusring,[type=\"button\"]:-moz-focusring,[type=\"reset\"]:-moz-focusring,[type=\"submit\"]:-moz-focusring{outline:1px dotted ButtonText}fieldset{padding:0.35em 0.75em 0.625em}legend{box-sizing:border-box;color:inherit;display:table;max-width:100%;padding:0;white-space:normal;}progress{vertical-align:baseline}textarea{overflow:auto}[type=\"checkbox\"],[type=\"radio\"]{box-sizing:border-box;padding:0;}[type=\"number\"]::-webkit-inner-spin-button,[type=\"number\"]::-webkit-outer-spin-button{height:auto}[type=\"search\"]{-webkit-appearance:textfield;outline-offset:-2px;}[type=\"search\"]::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit;}details{display:block}summary{display:list-item}template{display:none}[hidden]{display:none}html,body,div,span,applet,object,iframe,h1,h2,h3,h4,h5,h6,p,blockquote,pre,a,abbr,acronym,address,big,cite,code,del,dfn,em,img,ins,kbd,q,s,samp,small,strike,strong,sub,sup,tt,var,b,u,i,center,dl,dt,dd,ol,ul,li,fieldset,form,label,legend,table,caption,tbody,tfoot,thead,tr,th,td,article,aside,canvas,details,embed,figure,figcaption,footer,header,hgroup,menu,nav,output,ruby,section,summary,time,mark,audio,video{margin:0;padding:0;border:0;font-size:100%;font-style:inherit;vertical-align:baseline}:host{display:block;--ic-input-label-helpertext-padding:var(--ic-space-xxs);--border-color:var(--ic-text-field-border-neutral);--border-color-hover:var(--ic-text-field-border-neutral-hover);--border-color-pressed:var(--ic-text-field-border-neutral-pressed);--border-color-disabled:var(--ic-text-field-border-disabled);--border-color-error:var(--ic-text-field-border-error);--border-color-error-hover:var(--ic-text-field-border-error-hover);--border-color-error-pressed:var(--ic-text-field-border-error-pressed);--border-color-success:var(--ic-text-field-border-success);--border-color-success-hover:var(--ic-text-field-border-success-hover);--border-color-success-pressed:var(--ic-text-field-border-success-pressed);--border-color-warning:var(--ic-text-field-border-warning);--border-color-warning-hover:var(--ic-text-field-border-warning-hover);--border-color-warning-pressed:var(--ic-text-field-border-warning-pressed);--ic-input-label-text-color:var(--ic-text-field-label);--ic-input-label-helper-text-color:var(--ic-text-field-subtitle);--ic-input-validation-status-text-color:var(--ic-text-field-state-text);--ic-input-validation-error:var(--ic-text-field-state-icon-error);--ic-input-validation-warning-icon-color:var(\n    --ic-text-field-state-icon-warning\n  );--ic-input-validation-success-icon-color:var(\n    --ic-text-field-state-icon-success\n  );--ic-input-component-container-success-icon-inline-color:var(\n    --ic-text-field-state-icon-success\n  )}:host(.ic-text-field-disabled){--ic-input-label-text-color:var(--ic-text-field-label-disabled);--ic-input-label-helper-text-color:var(--ic-text-field-subtitle-disabled);--text-field-placeholder-color:var(\n    --ic-text-field-text-area-placeholder-text-disabled\n  )}:host(.ic-text-field-full-width){width:100%}::-moz-placeholder{color:var(\n    --text-field-placeholder-color,\n    var(--ic-text-field-placeholder-text)\n  );opacity:1}::placeholder{color:var(\n    --text-field-placeholder-color,\n    var(--ic-text-field-placeholder-text)\n  );opacity:1}input,textarea{border:0;border-radius:var(--ic-border-radius);color:var(--text-field-text-color, var(--ic-text-field-text));background-color:var(--input-bg-color, var(--ic-text-field-background));line-height:1.5rem;letter-spacing:0.005rem;width:100%;padding-right:var(--ic-space-xs);padding-left:var(--ic-space-xs);caret-color:var(\n    --text-field-typing-cursor,\n    var(--ic-text-field-typing-cursor)\n  )}textarea{min-height:var(--ic-space-lg);resize:vertical;padding-top:0.375rem}input:focus,textarea:focus{border:0;outline:0}input:disabled,textarea:disabled{color:var(\n    --text-field-disabled-text-color,\n    var(--ic-text-field-text-disabled)\n  )}input.readonly,textarea.readonly{color:var(--ic-text-field-read-only-input-text-internal);background:transparent}input::-webkit-outer-spin-button,input::-webkit-inner-spin-button{-webkit-appearance:none;margin:0}input[type=\"number\"]{-moz-appearance:textfield}textarea.no-resize{resize:none}.char-count-text{--ic-typography-color:var(--ic-text-field-character-limit);padding-right:var(--ic-space-xxxs)}:host(.ic-text-field-disabled) .char-count-text{--ic-typography-color:var(--ic-text-field-character-limit-disabled)}.no-left-pad{padding-left:0}::slotted([slot=\"icon\"]){fill:var(--ic-text-field-text-disabled)}.has-value ::slotted([slot=\"icon\"]){fill:var(--ic-text-field-input-internal-icon)}.char-count{margin-right:calc(-1 * var(--ic-space-xxxs))}.remaining-char-count-desc{position:absolute;left:-9999px}input[type=\"search\"]::-webkit-search-cancel-button,input[type=\"search\"]::-webkit-search-decoration,input[type=\"search\"]::-webkit-search-results-button,input[type=\"search\"]::-webkit-search-results-decoration{display:none}input[type=\"search\"].truncate-value{width:100%;overflow:hidden;white-space:nowrap;text-overflow:ellipsis}@media (forced-colors: active){input.readonly,textarea.readonly{color:canvastext}.has-value ::slotted([slot=\"icon\"]){fill:currentcolor}}";
const IcTextFieldStyle0 = icTextFieldCss;

let inputIds = 0;
const MUTABLE_ATTRIBUTES = [...IC_INHERITED_ARIA, "title"];
const TextField = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.getValidationText = createEvent(this, "getValidationText", 7);
        this.icBlur = createEvent(this, "icBlur", 7);
        this.icChange = createEvent(this, "icChange", 7);
        this.icFocus = createEvent(this, "icFocus", 7);
        this.icInput = createEvent(this, "icInput", 7);
        this.icKeydown = createEvent(this, "icKeydown", 7);
        this.icScroll = createEvent(this, "icScroll", 7);
        this.inheritedAttributes = {};
        this.hostMutationObserver = null;
        this.numChars = 0;
        this.maxCharactersReached = false;
        this.maxCharactersWarning = false;
        this.minCharactersUnattained = false;
        this.maxValueExceeded = false;
        this.minValueUnattained = false;
        /**
         * The automatic capitalisation of the text value as it is entered/edited by the user.
         * Available options: "off", "none", "on", "sentences", "words", "characters".
         */
        this.autocapitalize = "off";
        /**
         * The state of autocompletion the browser can apply on the text value.
         */
        this.autocomplete = "off";
        /**
         * The state of autocorrection the browser can apply when the user is entering/editing the text value.
         */
        this.autocorrect = "off";
        /**
         * If `true`, the form control will have input focus when the page loads.
         */
        this.autofocus = false;
        /**
         * If `true`, the disabled state will be set.
         */
        this.disabled = false;
        /**
         * Specify whether the text field fills the full width of the container.
         * If `true`, this overrides the --input-width CSS variable.
         */
        this.fullWidth = false;
        /**
         * The helper text that will be displayed for additional field guidance.
         */
        this.helperText = "";
        /**
         * If `true`, the character count which is displayed when `maxCharacters` is set will be visually hidden.
         */
        this.hideCharCount = false;
        /**
         * If `true`, the label will be hidden and the required label value will be applied as an aria-label.
         */
        this.hideLabel = false;
        /**
         * @internal If `true`, the hidden form input will stop rendering for form submission.
         */
        this.hiddenInput = true;
        /**
         * The ID for the input.
         */
        this.inputId = `ic-text-field-input-${inputIds++}`;
        /**
         * A hint to the browser for which keyboard to display.
         * Possible values: `"none"`, `"text"`, `"tel"`, `"url"`,
         * `"email"`, `"numeric"`, `"decimal"`, and `"search"`.
         */
        this.inputmode = "text";
        /**
         * The count of characters in the field. Will display a warning if the bound is reached. (NOTE: If the value of the text field has been set using the `value` prop, it will be truncated to this number of characters)
         */
        this.maxCharacters = 0;
        /**
         * The text to display as the warning message when the maximum number of characters (the `maxCharacters` prop value) is reached.
         */
        // prettier-ignore
        this.maxCharactersMessage = `Maximum input is ${this.maxCharacters} characters`;
        /**
         * The text to display as the error message when the maximum value (the `max` prop value) has been exceeded.
         */
        this.maxMessage = `Maximum value of ${this.max} exceeded`;
        /**
         * The minimum number of characters that can be entered in the field.
         */
        this.minCharacters = 0;
        /**
         * The text to display as the error message when the minimum number of characters (the `minCharacters` prop value) has not been met.
         */
        // prettier-ignore
        this.minCharactersMessage = `Minimum input is ${this.minCharacters} characters`;
        /**
         * The text to display as the error message when the minimum value (the `min` prop value) has not been met.
         */
        this.minMessage = `Minimum value of ${this.min} not met`;
        /**
         * The name of the control, which is submitted with the form data.
         */
        this.name = this.inputId;
        /**
         * The placeholder value to be displayed.
         */
        this.placeholder = "";
        /**
         * If `true`, the read only state will be set.
         */
        this.readonly = false;
        /**
         * If `true`, the input will require a value.
         */
        this.required = false;
        /**
         * If `true`, the multiline text area will be resizeable.
         */
        this.resize = false;
        /**
         * The number of rows to transform the text field into a text area with a specific height.
         */
        this.rows = 1;
        /**
         * The size of the text field component.
         */
        this.size = "medium";
        /**
         * If `true`, the value of the text field will have its spelling and grammar checked.
         */
        this.spellcheck = false;
        /**
         * Sets the theme color to the dark or light theme color. "inherit" will set the color based on the system settings or ic-theme component.
         */
        this.theme = "inherit";
        /**
         * @internal If `true`, an ellipsis will be displayed at the end of the value if the value is longer than the container.
         */
        this.truncateValue = false;
        /**
         * The type of control to display. The default type is text.
         */
        this.type = "text";
        /**
         * If `true`, the icon in input control will be displayed - only applies when validationStatus ='success'.
         */
        this.validationInline = false;
        /**
         *  @internal If `true`, the validation will display inline.
         */
        this.validationInlineInternal = false;
        /**
         * The validation state - e.g. 'error' | 'warning' | 'success'.
         */
        this.validationStatus = "";
        /**
         * The text to display as the validation message.
         */
        this.validationText = "";
        /**
         * The amount of time, in milliseconds, to wait to trigger the `icChange` event after each keystroke.
         */
        this.debounce = 0;
        /**
         * The value of the text field.
         */
        this.value = "";
        this.initialValue = this.value;
        this.checkChildHydration = () => {
            var _a, _b;
            if (this.hideLabel ||
                ((_b = (_a = this.el.shadowRoot) === null || _a === void 0 ? void 0 : _a.querySelector("ic-typography")) === null || _b === void 0 ? void 0 : _b.classList.contains("hydrated"))) {
                this.setFocus();
                clearInterval(this.interval);
            }
        };
        this.getNumberOfCharacters = (value) => value !== null && value !== undefined ? value.length : 0;
        this.getMaxValueExceeded = (value) => {
            this.numChars = this.getNumberOfCharacters(value);
            if (this.type === "number") {
                this.minValueUnattained = !!value && Number(value) < Number(this.min);
                this.maxValueExceeded = Number(value) > Number(this.max);
            }
        };
        this.getMaxCharactersReached = (value) => {
            this.numChars = this.getNumberOfCharacters(value);
            this.maxCharactersReached =
                this.maxCharacters > 0 && this.numChars >= this.maxCharacters;
            if (this.maxCharactersWarning && !this.maxCharactersReached) {
                this.maxCharactersWarning = false;
            }
        };
        this.onInput = (ev) => {
            this.value = ev.target.value;
            this.icInput.emit({ value: this.value });
        };
        this.onBlur = (ev) => {
            const target = ev.target;
            target.removeEventListener("wheel", this.onWheel);
            const { value } = target;
            this.numChars = value.length;
            this.minCharactersUnattained =
                this.minCharacters > 0 && this.numChars < this.minCharacters;
            this.icBlur.emit({ value });
        };
        this.onFocus = (ev) => {
            const target = ev.target;
            target.addEventListener("wheel", this.onWheel);
            this.icFocus.emit({ value: target.value });
        };
        this.onTextAreaScroll = () => {
            this.icScroll.emit();
        };
        this.onWheel = (ev) => {
            const target = ev.target;
            if (target.type === "number") {
                target.blur();
                setTimeout(() => {
                    target.focus();
                }, 0);
            }
        };
        this.hasStatus = (status) => status !== "" && !this.disabled;
        this.handleFormReset = () => {
            this.value = this.initialValue;
        };
        // triggered when attributes of host element change
        this.hostMutationCallback = (mutationList) => {
            let forceComponentUpdate = false;
            mutationList.forEach(({ attributeName, type, addedNodes, removedNodes }) => {
                if (attributeName && MUTABLE_ATTRIBUTES.includes(attributeName)) {
                    const attribute = this.el.getAttribute(attributeName);
                    if (attribute) {
                        this.inheritedAttributes[attributeName] = attribute;
                    }
                    forceComponentUpdate = true;
                }
                else if (type === "childList") {
                    forceComponentUpdate = checkSlotInChildMutations(addedNodes, removedNodes, "icon");
                }
            });
            if (forceComponentUpdate) {
                forceUpdate(this);
            }
        };
    }
    watchDisabledHandler() {
        removeDisabledFalse(this.disabled, this.el);
    }
    debounceChanged() {
        this.icChange = debounceEvent(this.icChange, this.debounce);
    }
    watchValueHandler(newValue) {
        let value;
        if (this.maxCharacters > 0) {
            value = newValue.substring(0, this.maxCharacters);
            if (value.length < newValue.length) {
                this.maxCharactersWarning = true;
            }
            this.value = value;
        }
        else {
            value = newValue;
        }
        if (this.inputEl && this.inputEl.value !== value) {
            this.inputEl.value = value;
        }
        this.getMaxValueExceeded(value);
        this.getMaxCharactersReached(value);
        this.icChange.emit({ value });
    }
    connectedCallback() {
        this.debounceChanged();
    }
    disconnectedCallback() {
        var _a;
        removeFormResetListener(this.el, this.handleFormReset);
        (_a = this.hostMutationObserver) === null || _a === void 0 ? void 0 : _a.disconnect();
    }
    componentWillLoad() {
        if (this.value !== this.initialValue) {
            this.watchValueHandler(this.value);
        }
        else if (this.maxCharacters > 0) {
            this.value = this.value.substring(0, this.maxCharacters);
        }
        this.getMaxValueExceeded(this.value);
        this.getMaxCharactersReached(this.value);
        this.inheritedAttributes = inheritAttributes(this.el, MUTABLE_ATTRIBUTES);
        if (this.readonly) {
            this.maxValueExceeded = false;
            this.minValueUnattained = false;
        }
        addFormResetListener(this.el, this.handleFormReset);
        removeDisabledFalse(this.disabled, this.el);
    }
    componentDidLoad() {
        onComponentRequiredPropUndefined([{ prop: this.label, propName: "label" }], "Text Field");
        if (this.validationInlineInternal) {
            this.getValidationText.emit({ value: this.validationText });
        }
        this.hostMutationObserver = new MutationObserver(this.hostMutationCallback);
        this.hostMutationObserver.observe(this.el, {
            attributes: true,
            childList: true,
        });
        if (this.autofocus && !this.disabled && !this.readonly) {
            this.interval = setInterval(this.checkChildHydration, 50);
        }
    }
    handleKeyDown(ev) {
        this.icKeydown.emit({ event: ev });
        if (!ev.ctrlKey && !IGNORED_KEYBOARD_CHARACTERS.includes(ev.key)) {
            this.maxCharactersWarning = this.maxCharactersReached;
        }
    }
    /**
     * Sets focus on the native `input`.
     */
    async setFocus() {
        var _a;
        (_a = this.inputEl) === null || _a === void 0 ? void 0 : _a.focus();
    }
    render() {
        const { inputId, name, label, required, size, placeholder, helperText, hideCharCount, rows, resize, disabled, value, min, max, numChars, readonly, maxCharacters, maxCharactersMessage, maxCharactersWarning, maxCharactersReached, maxMessage, minCharacters, minCharactersMessage, minCharactersUnattained, minMessage, minValueUnattained, maxValueExceeded, validationStatus, validationText, validationInline, validationInlineInternal, spellcheck, inputmode, fullWidth, truncateValue, hiddenInput, theme, hideLabel, type, autocapitalize, ariaActiveDescendant, inheritedAttributes, ariaExpanded, ariaOwns, autocomplete, role, } = this;
        const el = this.el;
        const disabledMode = readonly || disabled;
        const currentStatus = maxValueExceeded ||
            minValueUnattained ||
            minCharactersUnattained ||
            maxCharactersWarning
            ? maxCharactersWarning
                ? IcInformationStatus.Warning
                : IcInformationStatus.Error
            : validationStatus;
        const currentValidationText = maxCharactersWarning
            ? maxCharactersMessage
            : maxValueExceeded
                ? maxMessage
                : minValueUnattained
                    ? minMessage
                    : minCharactersUnattained
                        ? minCharactersMessage
                        : validationText;
        const maxNumChars = readonly ? 0 : maxCharacters;
        const messageAriaLive = maxCharactersWarning ||
            maxValueExceeded ||
            minValueUnattained ||
            currentStatus === IcInformationStatus.Error
            ? "assertive"
            : "polite";
        const showStatusText = this.hasStatus(currentStatus) &&
            !(currentStatus == IcInformationStatus.Success && validationInline) &&
            !validationInlineInternal;
        const multiline = rows > 1;
        const charsRemaining = maxNumChars - numChars;
        const hiddenCharCountDescId = maxCharacters > 0 ? `${inputId}-char-count-desc` : "";
        const describedBy = `${hiddenCharCountDescId} ${getInputDescribedByText(inputId, helperText !== "", showStatusText)}`.trim();
        const disabledText = disabledMode && !readonly;
        const showLeftIcon = !!this.el.querySelector(`[slot="icon"]`) && !disabledText;
        const invalid = `${currentStatus === IcInformationStatus.Error}`;
        hiddenInput
            ? renderHiddenInput(this.el, value, name, disabledMode)
            : removeHiddenInput(this.el);
        return (h(Host, { key: '392b43ac248502539bc00717694c10a24818551e', class: {
                "ic-text-field-full-width": fullWidth,
                "ic-text-field-disabled": disabledMode,
                [`ic-theme-${theme}`]: theme !== "inherit",
            } }, h("ic-input-container", { key: '59ec38e8e8e934cf48123303f68a7ca863badd83', readonly: readonly, disabled: disabledMode }, !hideLabel && (h("ic-input-label", { key: 'fa61768dd93e6d7a1ead043792b15b78b8d3fd26', for: inputId, label: label, helperText: helperText, required: required, disabled: disabledText, readonly: readonly })), h("ic-input-component-container", { key: 'c6ac9c16b6c565671575ec2217e62176d7bc1359', size: size, validationStatus: currentStatus, multiLine: multiline, disabled: disabledMode, readonly: readonly, validationInline: validationInline, fullWidth: fullWidth }, showLeftIcon && (h("span", { key: '353b7a992bbce4060dc5fe29b05f96aedd0cf32a', class: {
                readonly,
                "has-value": this.getNumberOfCharacters(value) > 0,
            }, slot: "left-icon" }, h("slot", { key: '8a5cbec45bedc43908caaae9ff74bc4101f995f8', name: "icon" }))), !multiline ? (h("input", Object.assign({ id: inputId, name: name, ref: (el) => (this.inputEl = el), type: type, min: min, max: max, value: value, class: {
                "no-left-pad": !showLeftIcon && readonly,
                readonly,
                "truncate-value": truncateValue,
            }, placeholder: placeholder ? placeholder : "", required: required, disabled: disabledMode, readonly: readonly, onInput: this.onInput, onBlur: this.onBlur, onFocus: this.onFocus, "aria-label": label, "aria-describedby": describedBy, "aria-invalid": invalid, "aria-activedescendant": ariaActiveDescendant, "aria-expanded": ariaExpanded, "aria-owns": ariaOwns, autocomplete: autocomplete, autocapitalize: autocapitalize, spellcheck: spellcheck, inputmode: inputmode, role: role, maxlength: maxCharactersReached ? maxCharacters : undefined, minlength: minCharactersUnattained ? minCharacters : undefined }, inheritedAttributes))) : (h("textarea", Object.assign({ id: inputId, class: {
                "no-resize": resize === false || !!readonly,
                "no-left-pad": !showLeftIcon && !!readonly,
                readonly: !!readonly,
            }, name: name, ref: (el) => (this.inputEl = el), value: value, rows: rows, required: required, disabled: disabledMode, placeholder: placeholder, readonly: readonly, onInput: this.onInput, onBlur: this.onBlur, onFocus: this.onFocus, onScroll: this.onTextAreaScroll, "aria-label": label, "aria-describedby": describedBy, "aria-invalid": invalid, autocapitalize: autocapitalize, spellcheck: spellcheck, inputmode: inputmode, maxlength: maxCharactersReached ? maxCharacters : undefined, minlength: minCharactersUnattained ? minCharacters : undefined }, inheritedAttributes))), isSlotUsed(el, "clear-button") && (h("slot", { key: '05d080fafd37f3c5e2894968705fe2802cd24f8a', name: "clear-button" })), isSlotUsed(el, "search-submit-button") && (h("slot", { key: 'b4ef1fb8db068a9c547d20147e31ac798cb838b5', name: "search-submit-button" }))), isSlotUsed(el, "menu") && h("slot", { key: '2f708851077d7cc70c6a90d2dae3f817ffdf469b', name: "menu" }), (!isEmptyString(validationStatus) ||
            !isEmptyString(validationText) ||
            maxNumChars > 0 ||
            maxValueExceeded ||
            maxCharactersWarning ||
            minCharactersUnattained ||
            minValueUnattained) &&
            !validationInlineInternal && (h("ic-input-validation", { key: 'd7c7b40ed97ab62e31fe09e78bf55c796948e33a', status: this.hasStatus(currentStatus) === false ||
                (currentStatus === IcInformationStatus.Success &&
                    validationInline) ||
                validationInlineInternal
                ? ""
                : currentStatus, message: showStatusText ? currentValidationText : "", ariaLiveMode: messageAriaLive, for: inputId, fullWidth: fullWidth }, !readonly && maxNumChars > 0 && (h("div", { key: '6b6d4c6b40f66756ceafc51c6ba7a336863ce030', slot: "validation-message-adornment" }, !hideCharCount && (h("ic-typography", { key: '5cb893f7e84654a848bd7ec14a0820583ed5d043', variant: "caption", class: "char-count-text" }, h("span", { key: 'b93ac422dbea08cf3d1f139feea1fd5ee37c6755', class: "char-count" }, numChars, "/", maxNumChars))), h("span", { key: 'e3b8a947bf1e4b1dc3bd93e04bb50ffaa55ac6a0', class: "remaining-char-count-desc", "aria-live": "polite" }, `${charsRemaining} character${charsRemaining === 1 ? "" : "s"} remaining.`), h("span", { key: '41353bf51d4e7264cc054f524b404519a953bec9', hidden: true, id: hiddenCharCountDescId }, "Field can contain a maximum of ", maxNumChars, " characters."))))))));
    }
    get el() { return getElement(this); }
    static get watchers() { return {
        "disabled": ["watchDisabledHandler"],
        "debounce": ["debounceChanged"],
        "value": ["watchValueHandler"]
    }; }
};
TextField.style = IcTextFieldStyle0;

export { TextField as ic_text_field };

//# sourceMappingURL=ic-text-field.entry.js.map