import { IcThemeMode } from "../../utils/types";
import { IcBackToTopVariants, IcBackToTopPositions } from "./ic-back-to-top.types";
export declare class BackToTop {
    private isTargetElNull;
    private targetEl;
    private topObserver;
    el: HTMLIcBackToTopElement;
    bannerOffset: boolean;
    footerVisible: boolean;
    targetElVisible: boolean;
    /**
     * The horizontal position of the element.
     */
    position?: IcBackToTopPositions;
    /**
     * The ID of the element to jump back to when the link is clicked.
     */
    target: string;
    /**
     * Sets the theme color to the dark or light theme color. "inherit" will set the color based on the system settings or ic-theme component.
     */
    theme?: IcThemeMode;
    /**
     * The variant of the button to render
     */
    variant?: IcBackToTopVariants;
    watchPropHandler(newValue: string, oldValue: string): void;
    componentWillLoad(): void;
    componentDidLoad(): void;
    private getObservedEl;
    private setTargetElVisible;
    private setFooterVisible;
    private targetElObserverCallback;
    private footerObserverCallback;
    private findTargetEl;
    private createTopObserver;
    private handleClick;
    private checkForClassificationBanner;
    render(): any;
}
