import { IcSizesNoLarge, IcThemeMode } from "../../utils/types";
/**
 * @slot label - Content will be rendered in the leftmost cell.
 * @slot value - Content will be rendered to the right of the label.
 * @slot end-component - Content will be displayed in the rightmost cell.
 */
export declare class DataRow {
    private hasEndComponent;
    private resizeObserver;
    el: HTMLIcDataRowElement;
    deviceSize: number;
    listSize: "xl" | "m" | "xs";
    /**
     * The label in the leftmost cell of the row.
     */
    label?: string;
    /**
     * The size of the data row component.
     */
    size?: IcSizesNoLarge;
    /**
     * Sets the theme color to the dark or light theme color. "inherit" will set the color based on the system settings or ic-theme component.
     */
    theme?: IcThemeMode;
    /**
     * The value of the middle (right if no end-component supplied) cell of the row.
     */
    value?: string;
    disconnectedCallback(): void;
    componentWillLoad(): void;
    componentDidLoad(): void;
    private runResizeObserver;
    private checkLabelAbove;
    private renderCellContent;
    private labelEndComponent;
    render(): any;
}
