import { IcBrand, IcOrientation, IcBrandForeground, IcThemeMode } from "../../utils/types";
import { IcDividerLabelPlacement, IcDividerStyles, IcDividerWeights } from "./ic-divider.types";
export declare class Divider {
    el: HTMLIcDividerElement;
    foregroundColor: IcBrandForeground;
    /**
     * The line style of the divider.
     */
    borderStyle?: IcDividerStyles;
    /**
     * The label for the divider. The label placement will need to be set for the label to be displayed correctly.
     */
    label?: string;
    /**
     * The position the label is placed on the divider. `Left` and `right` placement is only applicable when orientation is set to `horizontal`. `Top` and `bottom` placement is only applicable when orientation is set to `vertical`. `Center` placement is applicable for both orientations.
     */
    labelPlacement?: IcDividerLabelPlacement;
    /** If `true`, the divider will be displayed in a grey colour. */
    monochrome?: boolean;
    /**
     * The orientation of the divider.
     */
    orientation?: IcOrientation;
    /**
     * Sets the theme color to the dark or light theme color. "inherit" will set the color based on the system settings or ic-theme component.
     */
    theme?: IcThemeMode | IcBrandForeground;
    /**
     * The thickness of the divider.
     */
    weight?: IcDividerWeights;
    brandChangeHandler(ev: CustomEvent<IcBrand>): void;
    private updateMonochromeState;
    componentWillRender(): void;
    render(): any;
}
