import { EventEmitter } from "../../stencil-public-runtime";
import { IcThemeMode } from "../../utils/types";
/**
 * @slot navigation - Content will be rendered at top of panel.
 * @slot buttons - Content will be rendered above version info and below navigation.
 */
export declare class NavigationMenu {
    private closeButton?;
    private hasButtons;
    private hasNavigation;
    private lastTabStop;
    private navBarEl;
    private navGroupFirst;
    private navigationEls;
    private navItemAboveButtons;
    el: HTMLIcNavigationMenuElement;
    /**
     * The status info to display.
     */
    status?: string;
    /**
     * Sets the theme color to the dark or light theme color. "inherit" will set the color based on the system settings or ic-theme component.
     */
    theme?: IcThemeMode;
    /**
     * The version info to display.
     */
    version?: string;
    /**
     * @internal - Emitted when the menu is closed.
     */
    icNavigationMenuClose: EventEmitter<void>;
    componentWillLoad(): void;
    componentDidLoad(): void;
    componentWillRender(): void;
    navItemClickHandler(): void;
    handleKeyDown(ev: KeyboardEvent): void;
    private setLastTabStop;
    private closeMenu;
    private focusCloseButton;
    private focusLastTabStop;
    render(): any;
}
