import { IcThemeMode } from "../../utils/types";
export declare class SkipLink {
    private linkEl?;
    el: HTMLIcSkipLinkElement;
    /**
     * If `true`, the skip link will fill the width of the page.
     */
    fullWidth: boolean;
    /**
     * If `true`, the skip link will appear inline with surrounding page content when focused.
     */
    inline: boolean;
    /**
     * The label displayed when the skip link is focused.
     */
    label: string;
    /**
     * If `true`, the skip link will display as black in the light theme, and white in the dark theme.
     */
    monochrome: boolean;
    /**
     * The target ID for the element which should receive focus when triggering the skip link.
     */
    target: string;
    /**
     * Sets the theme color to the dark or light theme color. `inherit` will set the color based on the system settings or ic-theme component.
     */
    theme: IcThemeMode;
    /**
     * If `true`, the background will be hidden.
     */
    transparentBackground: boolean;
    /**
     * Sets focus on the element.
     */
    setFocus(): Promise<void>;
    render(): any;
}
