import { IcStatusTagStatuses } from "./ic-status-tag.types";
import { IcEmphasisType, IcSizes } from "../../utils/types";
export declare class StatusTag {
    /**
     * If `true`, role='status' is added to the component and it will act as an 'aria-live' region.
     * Screen readers will announce changes to the `label`, but not the initial value.
     */
    announced?: boolean;
    /**
     * The content rendered within the status tag.
     */
    label: string;
    /**
     * The size of the status tag component.
     */
    size?: IcSizes;
    /**
     * The colour of the status tag.
     */
    status?: IcStatusTagStatuses;
    /**
     * Sets the theme color to the dark or light theme color. "inherit" will set the color based on the system settings or ic-theme component.
     */
    theme?: "dark" | "light" | "inherit";
    /**
     * The letter case of the status tag's label.
     */
    uppercase?: boolean;
    /**
     * The emphasis of the status tag.
     */
    variant?: IcEmphasisType;
    componentDidLoad(): void;
    render(): any;
}
