import { IcStepVariants, IcStepStatuses, IcStepTypes } from "./ic-step.types";
import { IcThemeMode } from "../../utils/types";
export declare class Step {
    el: HTMLIcStepElement;
    /**
     * @internal If a compact stepper is being used, this sets the styling of the step.
     */
    compactStepStyling?: IcStepTypes;
    /**
     * @internal If `true`, and a compact stepper  is being used, the current step will be the only step in view.
     */
    current?: boolean;
    /**
     * @internal If `true`, the step will be marked as being the last one in the series. This is managed by ic-stepper.
     */
    lastStep: boolean;
    /**
     * @internal The step number of the final step. This is managed by ic-stepper.
     */
    lastStepNum?: number;
    /**
     * @internal The name of the next step. This is managed by ic-stepper.
     */
    nextStepHeading?: string;
    /**
     * @internal The progress of the next step, calculated by dividing the current step number by the total number of steps. This is managed by ic-stepper.
     */
    progress?: number;
    /**
     * @internal The step number, managed by ic-stepper.
     */
    stepNum?: number;
    /**
     * The status of the step. Use this prop to display a status message on the step if it is required or optional.
     */
    status?: IcStepStatuses;
    /**
     * Additional information about the step. Use this prop to override the default step status messaging displayed when selecting a step type or step status.
     */
    subheading?: string;
    /**
     * The title of the step within the stepper.
     */
    heading?: string;
    /**
     * @internal Sets the theme color to the dark or light theme color. "inherit" will set the color based on the system settings or ic-theme component.
     */
    theme?: IcThemeMode;
    /**
     * @internal The variant of the step. This is managed by ic-stepper.
     */
    variant: IcStepVariants;
    /**
     * The state of the step within the stepper.
     */
    type?: IcStepTypes;
    typeChangeHandler(): void;
    render(): any;
}
