import { EventEmitter } from "../../stencil-public-runtime";
import { IcColor, IcBrand, IcThemeSettings } from "../../utils/types";
export declare class Theme {
    themeClass: string;
    /**
     * The brand colour. Can be a hex value e.g. "#ff0000", RGB e.g. "rgb(255, 0, 0)", or RGBA e.g. "rgba(255, 0, 0, 1)".
     */
    brandColor?: IcColor | null;
    watchBrandColorPropHandler(): void;
    /**
     * The theme mode. Can be "dark", "light", or "system". "system" will use the device or browser settings.
     */
    theme?: IcThemeSettings;
    watchThemePropHandler(): void;
    /**
     * @internal Emitted when the brand color is changed.
     */
    brandChange: EventEmitter<IcBrand>;
    /**
     * Emitted when the theme is changed.
     */
    icThemeChange: EventEmitter<IcThemeSettings>;
    componentWillLoad(): void;
    private darkModeChangeHandler;
    private checkBrandColorContrast;
    private setBrandColor;
    render(): any;
}
